version$="v1.10"
    'Mayhem!
    'A Just BASIC Game - Originally in Liberty BASIC
    'Copyright 1995, 2000, 2004 Carl Gundel and Steve Woodward

    'Mayhem is a game where two tanks shoot at each other in a ramdomly
    'generated landscape!   Each tank's gun is aimed by inputting an
    'angle from the horizon, and a number of pounds of TNT to propell a
    'shell with.

    'Note: There is nothing to force the players to
    'take turns while playing.


    'How to shoot
    '--------------------------------------------------------------------

    'Pick an angle from 1 to 90 degrees of the horizon and input it.
    'Then pick a quantity of pounds of TNT to use 1 - 20 (more or less)
    'and input that.  Then click on the fire button!

    'Now if you miss, give the other chap a shot at you!  And round you
    'go!!!


    'Modifying the game
    '--------------------------------------------------------------------

    'When you get bored of Mayhem, add features to make it interesting.
    'Try making it three players, or four!  Make the ground invisible
    'so that you have to hit it with a shell to 'feel' your way around it!
    'Add some cool sound effects or a dramatic musical score!
    'Try giving each player a limited number of shells, or a limited
    'quantity of TNT.  Or all of the above with a setup screen!  Use your
    'imagination, and then share your code with all of us!

    'Special thanks to Steve Woodward for inspiring me to write this game!

    pinetreenumber=int(rnd(1)*25+50)
    dim terrain(1000)
    WindowWidth = 200
    WindowHeight = 1
    UpperLeftX=WindowWidth/2-100
    UpperLeftY=WindowHeight/2
    nomainwin
    open "Loading..." for window as #loading
    PLAYMIDI  "media\music1.mid", A
    close #loading
    hang=1
    zeneplaying=1
    loadbmp "lefttank", "bmp\ltank.bmp"
    loadbmp "righttank", "bmp\rtank.bmp"
    loadbmp "lefttankn", "bmp\ltankn.bmp"
    loadbmp "righttankn", "bmp\rtankn.bmp"
    loadbmp "leftbang", "bmp\lbang.bmp"
    loadbmp "leftbangn", "bmp\lbangn.bmp"
    loadbmp "sun", "bmp\sun.bmp"
    loadbmp "hold", "bmp\moon.bmp"
    loadbmp "felh", "bmp\felh.bmp"
    loadbmp "csillag", "bmp\stars.bmp"

    WindowWidth = 1000
    WindowHeight = 444
    UpperLeftX = 10
    UpperLeftY = 10

    menu #mayhem, "&Game", "&New Game", [newGame], "&Zero scores", [Pont], "&About the Armageddon", [aboutMayhem], "&Exit", [exit]
    menu #mayhem, "&Settings", "&Music on/off", [zenebeki], "&sound on/off", [hangbeki]
    statictext #mayhem.statictext1, "Degree", 22, 336, 40, 20
    textbox #mayhem.angleUsa, 70, 331, 100, 25
    statictext #mayhem.statictext3, "TNT", 22, 366, 26, 20
    textbox #mayhem.tntUsa, 70, 361, 45, 25
    button #mayhem, "Fire!", [fireUsa], UL, 120, 361
    statictext #mayhem.statictext2, "Degree", 822, 336, 40, 20
    textbox #mayhem.angleUssr, 870, 331, 100, 25
    statictext #mayhem.statictext4, "TNT", 822, 366, 26, 20
    textbox #mayhem.tntUssr, 870, 361, 45, 25
    button #mayhem, "Fire!", [fireUssr], UL, 920, 361
    graphicbox #mayhem.graphics, 0, 0, 970, 330
    listbox #main.list, pick$(), [WAIT], 170, 361, 184, 100
    listbox #main.list2, pick$(), [WAIT], 208, 280, 184, 100
     statictext #mayhem.statictext8, "Size of exploding", 450, 336, 120, 20
    textbox #mayhem.seb ,450,360,50,20
    open "Armageddon "+version$ for window_nf as #mayhem
    print #mayhem.angleUsa, "!setfocus"
    print #mayhem, "trapclose [exit]"
    listbox #A.usafegyv, pick$(), [wait], 398, 2, 50, 30
    listbox #A.ussrfegyv, pick$(), [wait], 398, 2, 50, 30

dim felhx(2)
[midilist]
dim midis$(5)
nowmidi=1
for V1=1 to 5
midis$(V1)="media\music"+str$(V1)+".mid"
next V1
goto [newGame]
[midipick]
if nowmidi<>5 then nowmidi=nowmidi+1 else nowmidi=1
return
[newGame]
napszak=int(rnd(1)*2+1)
fmagassg=int(rnd(1)*8+2)
fafajta=int(rnd(1)*2)
 sunx=int(rnd(1)*950)
 felhx(1)=sunx-500
 felhx(2)=sunx+500
    m=int(rnd(1)*80)
    n=int(rnd(1)*80+93)
    b=int(rnd(1)*80)
    $=str$(m)+" "+str$(n)+" "+str$(b)
    rate1 =rnd(1) / (rnd(1) * 20 + 10)
    rate2 = rnd(1) / (rnd(1) * 6 + 10)
    windspeed = int(rnd(1) * 50) - 25
    usaX = int(rnd(1) * 100) + 25
    ussrX = int(rnd(1) * 100) + 800
    dim pinetrees(pinetreenumber+1,4)
    for q=1 to pinetreenumber
    pinetrees(q,1)=int(rnd(1)*1000)
    pinetrees(q,2)=int(rnd(1)*50+20)
    pinetrees(q,3)=int(rnd(1)*20+3)
    next q
if napszak=1 then print #mayhem.graphics, "cls ;fill cyan" else  print #mayhem.graphics, "cls ;fill blue"
print #mayhem.graphics, "down ; color "; $
    print #mayhem.graphics," size 3"
 for x = 0 to 999 step 2
        holder1 = holder1 + rate1
        holder2 = holder2 + rate2
        holder3 = holder3 + sin(holder2) / 20
        y = 200 + int(sin(holder1) * 75) + int(cos(holder2) * 30) + int(cos(holder3) * 10)
    terrain(x) = y : terrain(x + 1) = y
    next x
    for x = ussrX - 17 to ussrX + 17 : terrain(x) = terrain(ussrX) : next x
for x = usaX - 17 to usaX + 17 : terrain(x) = terrain(usaX) : next x
for x = 0 to 999 step 2
    y = terrain(x + 1)
   print #mayhem.graphics, "line "; x; " "; y; " "; x; " 410"
   next x
[Drawing]

if napszak=1 then print #mayhem.graphics, "cls ;fill cyan" else  print #mayhem.graphics, "cls ;fill blue"
print #mayhem.graphics, "down ; color "; $
   print #mayhem.graphics," size 3"
    if napszak=1 then
    print #mayhem.graphics, "drawbmp lefttank "; usaX - 16; " "; terrain(usaX) - 32;
    print #mayhem.graphics, "drawbmp righttank "; ussrX - 16; " "; terrain(ussrX) - 32;
    else
    print #mayhem.graphics, "drawbmp lefttankn "; usaX - 16; " "; terrain(usaX) - 32;
    print #mayhem.graphics, "drawbmp righttankn "; ussrX - 16; " "; terrain(ussrX) - 32;
    end if
   for x = 0 to 999 step 2
    y = terrain(x + 1)
   print #mayhem.graphics, "line "; x; " "; y; " "; x; " 410"
   next x
 print #mayhem.graphics, "down ; color white"
   'print #mayhem.graphics," size 3"
   'for x = 0 to 999 step 2
   'y=terrain(x+1)
   'if y>200 then print #mayhem.graphics, "line "; x; " ";200; " "; x; "";y
   'next x
 [rtz]
  if napszak=1 then
    print #mayhem.graphics, "drawbmp sun "; sunx; " "; 20;
    print #mayhem.graphics, "drawbmp felh "; felhx(1); " "; 20;
    print #mayhem.graphics, "drawbmp felh "; felhx(2); " "; 20;
    else
    print #mayhem.graphics, "drawbmp hold "; sunx; " "; 20;
    print #mayhem.graphics, "drawbmp csillag "; felhx(1); " "; 20;
    print #mayhem.graphics, "drawbmp csillag "; felhx(2); " "; 20;

end if
    gosub [fmake]
for w=1 to pinetreenumber
LSZ=int(rnd(1)*10+11)
    gosub [fenyodraw]
next w


    print #mayhem.graphics, "place 10 15"

    if napszak=1 then print #mayhem.graphics, "color black ; backcolor cyan" else print #mayhem.graphics, "color white ; backcolor blue"
    if windspeed < 0 then print #mayhem.graphics, "\Wind <<"; abs(windspeed); "<<"
    if windspeed = 0 then print #mayhem.graphics, "\Wind <<0>>"
    if windspeed > 0 then print #mayhem.graphics, "\Wind >>"; windspeed; ">>"
    print #mayhem.graphics, "place 100 15"
    if napszak=1 then print #mayhem.graphics, "color black ; backcolor cyan" else print #mayhem.graphics, "color white ; backcolor blue"
    #mayhem.graphics, "\USA ";usapont;" : ";szopont;" USSR"

    print #mayhem.graphics, "flush"
    print #mayhem.graphics, "segment" : input #mayhem, segId

 if mox=1 then goto [nor]

[main.inputLoop]   'wait here for input event
    input aVar$
    if A = midipos( ) then
                      stopmidi
                      gosub [midipick]
                      PLAYMIDI midis$(nowmidi) , A
    end if
    goto [main.inputLoop]


[fireUsa]   'the USA fires its gun!
    print #mayhem.seb, "!contents? seb$"
    m=val(seb$)
if m>60 then
               notice "The size of the exploding is too big!"
               wait
end if
    print #mayhem.angleUsa, "!contents?" : input #mayhem.angleUsa, angle
    print #mayhem.tntUsa, "!contents?" : input #mayhem.tntUsa, tnt
    if tnt>350 then [explodeUsa]
    if tnt <= 1 then
        notice "What are you kidding?  Put more tnt in there unless you wanna blow yourself up!"
        goto [main.inputLoop]
    end if
    if hang=1 then playwave "media/exp2.wav", asynch
    direction = 1
    x = usaX
    y = terrain(x) - 16

    goto [trackShell]




[fireUssr]   'the USSR fires its gun!
print #mayhem.seb, "!contents? seb$"
    m=val(seb$)
    if m>60 then
               notice "The size of the exploding is too big!"
               wait
end if
    print #mayhem.angleUssr, "!contents?" : input #mayhem.angleUssr, angle
    print #mayhem.tntUssr, "!contents?" : input #mayhem.tntUssr, tnt
    if tnt>350 then [explodeUssr]
    if tnt <= 1 then
        notice "What are you kidding?  Put more tnt in there unless you wanna blow yourself up! (how do you say this in Russian?)"
        goto [main.inputLoop]
    end if
    if hang=1 then playwave "media/exp2.wav", asynch
    direction = -1
    x = ussrX
    y = terrain(x) - 16

    goto [trackShell]





[trackShell]
    print #mayhem.graphics, "size 3; color black"
    live = 1
    explode = 0
    tnt = tnt * 10
    windEffect = windspeed / 50
    angleXform = angle / 180 * 3.14
    xVelocity = (cos(angleXform) * tnt + 0.001) * direction
    yVelocity = sin(angleXform) * tnt + 0.001
    adjust = 3 / yVelocity
    if abs(xVelocity) > yVelocity then adjust = 3 / xVelocity * direction
    xVelocity = xVelocity * adjust * 2
    yVelocity = yVelocity * adjust * 2
    lastX = 0 : lastY = 0
    print #mayhem.graphics, "rule xor"
    while live = 1
        gosub [waitIfNeeded]
        x = x + xVelocity + windEffect
        y = y - yVelocity
        yVelocity = yVelocity - (32 * adjust)
        print #mayhem.graphics, "place "; x; " "; y
        print #mayhem.graphics, "go 1"
        if lastX = 0 then [firstTimeUsa]
        print #mayhem.graphics, "place "; lastX; " "; lastY
        print #mayhem.graphics, "go 1"
      [firstTimeUsa]
        lastX = x : lastY = y
        if x < 1 or x > 999 then live = 0
        if x < 0 then x = 0
        if x > 1000 then x = 1000
        if live = 1 and y >= terrain(int(x)) then live = 0 : explode = 1
    wend

    print #mayhem.graphics, "discard ; flush"

    if explode = 0 then gosub [setFocus] : goto [main.inputLoop]

    explodeX = x
    explodeY = y
    gosub [explosion]

    gosub [setFocus]
[die]
    if x >= usaX - 17 and x <= usaX + 17 then [explodeUsa]
    if x >= ussrX - 17 and x <= ussrX + 17 then [explodeUssr]
return
    goto [main.inputLoop]


[setFocus]   'set the appropriate user's focus

    if direction < 1 then
        print #mayhem.angleUsa, "!setfocus"
      else
        print #mayhem.angleUssr, "!setfocus"
    end if
    return


[waitIfNeeded]  'keep the game from running too fast on fast machines

    if tnt = 0 then tnt = 1
    newTime = time$("milliseconds")
    while newTime < oldTime + (30/(tnt/1000))
        newTime = time$("milliseconds")
    wend
    oldTime = newTime
    return

[explosion]   'Make an explosion at explodeX explodeY

    explodeRate = 2
    explodeSpeed = explodeRate * 100
    if hang=1 then playwave "media/exp1.wav", asynch
    if hit = 0 then print #mayhem.graphics, "rule xor"
    print #mayhem.graphics, "size "; explodeRate
    print #mayhem.graphics, "place "; explodeX; " "; explodeY

    if hit = 1 then explodeSize = 42 else explodeSize = 18

    print #mayhem.graphics, "circle "; 6 - explodeRate
    for radius =  10 to explodeSize step explodeRate
        print #mayhem.graphics, "circle "; radius
        call pause
        print #mayhem.graphics, "circle "; radius - explodeRate
    next radius
    print #mayhem.graphics, "circle "; explodeSize
    print #mayhem.graphics, "rule over"

    print #mayhem.graphics, "discard"
goto [landing]
[nor]
mox=0
    return


sub pause    'pause for a tenth of a second

    start = time$("ms")
    while start + 2 > time$("ms")
    wend

end sub


[explodeUsa]  'blow up the Usa tank
     if hang=1 then playwave "media/exp1.wav", asynch
    if napszak=1 then print #mayhem.graphics, "drawbmp leftbang "; usaX - 16; " "; terrain(usaX)-32
    if napszak=2 then print #mayhem.graphics, "drawbmp leftbangn "; usaX - 16; " "; terrain(usaX) -32
    print #mayhem.graphics, "delsegment "; segId
    now$ = time$() : while time$() = now$ : wend
    szopont=szopont+1
    notice "The USSR won this round."
    goto [newGame]


[explodeUssr]  'blow up the Ussr tank
  if hang=1 then playwave "media/exp1.wav", asynch
     if napszak=1 then print #mayhem.graphics, "drawbmp leftbang "; ussrX - 16; " "; terrain(ussrX)-32
    if napszak=2 then print #mayhem.graphics, "drawbmp leftbangn "; ussrX - 16; " "; terrain(ussrX) -32
    print #mayhem.graphics, "delsegment "; segId
    now$ = time$() : while time$() = now$ : wend
    usapont=usapont+1
    notice "The USA won this round!"
    goto [newGame]


[aboutMayhem]  'Display an "About Mayhem!" dialog box

    WindowWidth = 370
    WindowHeight = 150

    statictext #main.statictext1, "Armageddon "+version$+" The game (originally Mayhem) ", 14, 26, 310, 40
    statictext #main.statictext2, "made by Liberty and upgraded by Adam Hda", 14, 46, 304, 30
    statictext #main.statictext3, "2006.", 24, 76, 178, 50
    button #main, "OK", [aboutOK], UL, 214, 76
    open "About the Armageddon "+version$ for dialog as #main
    print #main, "trapclose [aboutOK]"

    goto [main.inputLoop]


[aboutOK]   'Perform action for the button named 'aboutOK'

    close #main

    goto [main.inputLoop]

[Pont]
usapont=0
szopont=0
goto [newGame]

[landing]
gosub [die]

if explodeX<0   then [nor]
if explodeX>999 then [nor]
if m=0 then m=10
g=-1*m
h=1
goto[lnd1]

[lnd1]
if explodeX+g>0 then terrain(explodeX+g)=terrain(explodeX+g) + h
 g=g+1
if h=m then goto [lnd2]
h=h+1
goto [lnd1]

[lnd2]
if explodeX+g>0 then terrain(explodeX+g)=terrain(explodeX+g) + h
g=g+1
if h=0 then goto [Drawing]
h=h-1
goto [lnd2]

[zenebeki]
if zeneplaying=1 then
                stopmidi
                zeneplaying=0
                 else
                zeneplaying=1
                 gosub [midipick]
                 PLAYMIDI midis$(nowmidi) , A
end if
goto [WAIT]
[sok]
mox=1
print #mayhem.graphics, "cls"
goto [Drawing]

[exit]  'Quit Mayhem!

    confirm "Are you sure?"; answer$
    if answer$ <> "yes" then [main.inputLoop]
    if zeneplaying=1 then stopmidi
    close #mayhem
    end

[hangbeki]
if hang=1 then hang=0 else hang=1
goto [WAIT]
[WAIT]
wait


[fenyodraw]
print #mayhem.graphics, "size 3; color brown"
R=int(rnd(1)*80)
G=int(rnd(1)*80+93)
B=int(rnd(1)*80)
print #mayhem.graphics, "line "; pinetrees(w,1); " "; terrain(pinetrees(w,1)); " "; pinetrees(w,1); " ";terrain(pinetrees(w,1))-pinetrees(w,2)
print #mayhem.graphics, "size 1;color ";R;" ";G;" ";B
if fafajta=0 then
for v=-10 to 10
print #mayhem.graphics, "line "; pinetrees(w,1); " "; terrain(pinetrees(w,1))-pinetrees(w,2); " "; pinetrees(w,1)-v; " ";terrain(pinetrees(w,1))-3
next v

end if
if fafajta=1 then
                     print #mayhem.graphics, "backcolor ";R;" ";G;" ";B;";  color ";R;" ";G;" ";B;" ;place "; pinetrees(w,1);" ";terrain(pinetrees(w,1))-pinetrees(w,2)
                     print #mayhem.graphics, "circlefilled ";pinetrees(w,3)
end if
return

[fmake]
print #mayhem.graphics, "size 1 ; color ";R;" ";G;" ";B
for V2=3 to 1000 step 5
print #mayhem.graphics, "line ";V2;" ";terrain(V2);" ";V2-3;" ";terrain(V2)-fmagassg
print #mayhem.graphics, "line ";V2;" ";terrain(V2);" ";V2;" ";terrain(V2)-(fmagassg+2)
print #mayhem.graphics, "line ";V2;" ";terrain(V2);" ";V2+3;" ";terrain(V2)-fmagassg
next V2
return
